/**
 * Created by IntelliJ IDEA.
 * User: Luchesar
 * Date: May 2, 2004
 * Time: 10:02:13 AM
 * To change this template use Options | File Templates.
 */
package inet.warehouse.model;

import inet.warehouse.model.persistance.APersister;
import inet.warehouse.model.persistance.PersistanceFactory;
import inet.warehouse.model.persistance.ObjectNotFoundException;
import inet.warehouse.model.persistance.Id;
import inet.warehouse.model.persistance.PersistenceException;
import org.apache.commons.beanutils.PropertyUtils;

import java.beans.PropertyDescriptor;
import java.util.HashMap;
import java.util.Map;
import java.lang.reflect.InvocationTargetException;

public abstract class AModel implements java.io.Serializable {
    protected Id mId;
    protected static APersister mPersister = PersistanceFactory.newInstance().getPersister();

    public AModel() {
        mId = new Id();
    }

    public Id getId() {
        return mId;
    }

    public void setId(Id aId) {
        mId = aId;
    }

    public AModel create() throws PersistenceException {
        return mPersister.create(getClass());
    }

    public void save() throws PersistenceException {
        mPersister.save(this);
    }

    public void delete() throws ObjectNotFoundException {
        mPersister.delete(getClass(), getId());
    }

    public AModel load() throws ObjectNotFoundException, PersistenceException {
        return mPersister.load(getClass(), getId());
    }

    public AModel[] filter() throws PersistenceException {
        try {
            HashMap propValues = propertyMap();
            return mPersister.listBy(getClass(), propValues);
        } catch (PersistenceException e) {
            throw e;
        } catch (Exception e) {
            throw new PersistenceException(e);
        }
    }

    private HashMap propertyMap() throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {
        PropertyDescriptor[] descs = PropertyUtils.getPropertyDescriptors(getClass());
        HashMap propValues = new HashMap();
        for (int i = 0; i < descs.length; i++) {
            PropertyDescriptor desc = descs[i];
            if (!"id".equals(desc.getName()) &&
                    !AModel.class.isAssignableFrom(desc.getPropertyType()) &&
                    !AModel[].class.isAssignableFrom(desc.getPropertyType()) &&
                    desc.getWriteMethod() != null) {
                Object value = PropertyUtils.getProperty(this, desc.getName());
                if (value != null) {
                    propValues.put(desc.getName(),value);
                }
            }
        }
        return propValues;
    }

    public AModel[] filter(String[] orderBy) throws PersistenceException {
        try {
            HashMap propValues = propertyMap();
            return mPersister.listBy(getClass(), propValues,orderBy);
        } catch (PersistenceException e) {
            throw e;
        } catch (Exception e) {
            throw new PersistenceException(e);
        }
    }

    public static AModel[] listAll(Class aClass) throws PersistenceException {
        return mPersister.listAll(aClass);
    }

    public static AModel[] findBy(Class aClass, String aPropertyName, Object aPropertyValue) throws PersistenceException {
        return mPersister.listBy(aClass, aPropertyName, aPropertyValue);
    }

    public static void deleteAll(Class aClass) throws PersistenceException {
        mPersister.deleteAll(aClass);
    }

    public static AModel[] listAll(Class aClass,String[] orderBy) throws PersistenceException {
        return mPersister.listAll(aClass,orderBy);
    }

    public static AModel[] findBy(Class aClass, String aPropertyName, Object aPropertyValue,String[] orderBy) throws PersistenceException {
        return mPersister.listBy(aClass, aPropertyName, aPropertyValue,orderBy);
    }

    public static AModel[] findBy(Class aClass, Map mapping,String[] orderBy) throws PersistenceException {
        return mPersister.listBy(aClass, mapping,orderBy);
    }
}
