/**
 * Created by IntelliJ IDEA.
 * User: Luchesar
 * Date: May 2, 2004
 * Time: 7:55:03 PM
 * To change this template use Options | File Templates.
 */
package inet.warehouse.model.persistance;

import inet.warehouse.util.Base64;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.StringTokenizer;

public class Id implements java.io.Serializable,Comparable {
    public long currentTime;
    public int ip;
    public int random;

    public Id() {
        try {
            currentTime = System.currentTimeMillis();
            ip = byteArrToInt(InetAddress.getLocalHost().getHostAddress().getBytes());
            random = (int) Math.round(Math.random() * Integer.MAX_VALUE);
        } catch (UnknownHostException e) {
        }
    }

    public Id(String idString) {
            StringTokenizer t = new StringTokenizer(idString,"-");
            ip = Integer.parseInt(t.nextToken(),Character.MAX_RADIX);
            currentTime = Long.parseLong(t.nextToken(),Character.MAX_RADIX);
            random = Integer.parseInt(t.nextToken(),Character.MAX_RADIX);
    }


    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Id)) return false;

        final Id id = (Id) o;

        if (currentTime != id.currentTime) return false;
        if (ip != id.ip) return false;
        if (random != id.random) return false;

        return true;
    }

    public int hashCode() {
        int result;
        result = (int) (currentTime ^ (currentTime >>> 32));
        result = 29 * result + ip;
        result = 29 * result + (int) (random ^ (random >>> 32));
        return result;
    }

    public String toString() {
        return Integer.toString(ip, Character.MAX_RADIX) + "-" +
                Long.toString(currentTime, Character.MAX_RADIX) + "-" +
                Integer.toString(random, Character.MAX_RADIX);
    }


    /*private static final byte[] intToByteArr(int i) {
        return new byte[]
        {
            (byte) (i >> 24),
            (byte) ((i >> 16) & 0xFF),
            (byte) ((i >> 8) & 0xFF),
            (byte) (i & 0xFF)
        };
    }

    private static final byte[] longToByteArr(long i) {
        return new byte[]
        {
            (byte) (i >> 56 & 0xFF),
            (byte) ((i >> 48) & 0xFF),
            (byte) ((i >> 40) & 0xFF),
            (byte) ((i >> 32) & 0xFF),
            (byte) ((i >> 24) & 0xFF),
            (byte) ((i >> 16) & 0xFF),
            (byte) ((i >> 8) & 0xFF),
            (byte) (i & 0xFF),
        };
    }*/

    private final int byteArrToInt(byte[] array) {
        return (0xFF & array[0]) << 24 |
                (0xFF & array[1]) << 16 |
                (0xFF & array[2]) << 8 |
                (0xFF & array[3]);
    }

    public int compareTo(Object o) {
        if (this == o) return 0;
        if (!(o instanceof Id) || o == null) return 1;

        return toString().compareTo(((Id)o).toString());
    }
}
