package inet.warehouse.model.persistance.file;

import org.apache.commons.beanutils.PropertyUtils;

import java.util.Comparator;
import java.util.Collections;
import java.util.Set;
import java.util.HashSet;
import java.lang.reflect.InvocationTargetException;

import inet.warehouse.model.AModel;
import inet.warehouse.model.persistance.Id;

/*
 * $Id: BaseRuntimeException.java,v 1.1 2003/07/15 20:20:59 alvin Exp $
 * Copyright (c) 2001-03 Westbridge Technology, Inc.  All Rights Reserved.
 */

public class BeanComparator implements Comparator {
    private String[] propertiesТoCompare;

    private static final Set simpleTypes = new HashSet();
    static {
        simpleTypes.add(String.class);
        simpleTypes.add(Byte.class);
        simpleTypes.add(Short.class);
        simpleTypes.add(Integer.class);
        simpleTypes.add(Long.class);
        simpleTypes.add(Float.class);
        simpleTypes.add(Double.class);
        simpleTypes.add(Character.class);
        simpleTypes.add(Boolean.class);
        simpleTypes.add(Class.class);
        simpleTypes.add(Id.class);
    }

    public BeanComparator(String[] aPropertiesТoCompare) {
        propertiesТoCompare = aPropertiesТoCompare;
    }

    public int compare(Object o1, Object o2) {
        int result = 0;
        try {

            for (int i = 0; i < propertiesТoCompare.length; i++) {
                String s = propertiesТoCompare[i];

                Object value1 = null;
                Object value2 = null;
                value1 = PropertyUtils.getProperty(o1, s);
                value2 = PropertyUtils.getProperty(o2, s);

                if (value1 == null) {
                    if (value2 != null) {
                        result = 1;
                    }
                } else {
                    if (simpleTypes.contains(value1.getClass())) {
                        result = ((Comparable)value1).compareTo(value2);
                    }
                }

                if (result != 0) break;
            }
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
        return result;
    }

}
