package inet.warehouse.web.actions;

import inet.warehouse.web.Action;
import inet.warehouse.web.ActionException;
import inet.warehouse.web.Constants;
import inet.warehouse.model.AModel;
import inet.warehouse.model.User;
import inet.warehouse.model.Warehouse;
import inet.warehouse.model.Good;
import inet.warehouse.model.persistance.Id;
import inet.warehouse.model.persistance.PersistenceException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GoodsList extends Action {
    public static final String PAGE_OK = "/goodsList.jsp";

    public static final String VAR_GOODS = "goods";

    public String execute(HttpServletRequest request, HttpServletResponse response) throws ActionException {
        User user = (User) request.getSession().getAttribute( Constants.AUTHENTICATED_USER_SESSION_KEY );
        Warehouse[] userWarehouses = user.getWarehouses();

        if( userWarehouses.length > 0 ) {
            Good good = new Good();
            good.setWarehouse( userWarehouses[0] );

            try {
                Good[] foundGoods = (Good[]) good.filter();
                request.setAttribute( VAR_GOODS, foundGoods );
            } catch (PersistenceException e) {
                throw new ActionException( e );
            }
        }

        return PAGE_OK;
    }
}
