/**
 * Created by IntelliJ IDEA.
 * User: Luchesar
 * Date: May 11, 2004
 * Time: 9:42:10 PM
 * To change this template use Options | File Templates.
 */
package inet.warehouse.web.actions;

import inet.warehouse.web.Action;
import inet.warehouse.web.ActionException;
import inet.warehouse.web.Constants;
import inet.warehouse.model.AModel;
import inet.warehouse.model.User;
import inet.warehouse.model.persistance.PersistenceException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Login extends Action {
    public static final String PAGE_FAIL = "/";
    public static final String PAGE_OK = "/main.jsp";

    private static final String REQ_USERNAME = "username";
    private static final String REQ_PASSWORD = "password";

    public static final String VAR_CURRENT_USERNAME = "currentUsername";

    public String execute(HttpServletRequest request, HttpServletResponse response) throws ActionException {
        try {
            // parameters
            String username = request.getParameter(REQ_USERNAME);
            String password = request.getParameter(REQ_PASSWORD);

            User user = new User();
            user.setUserName(username);
            user.setPassword(password);

            // finds a user by username and password
            User[] all = (User[])user.filter();

            if (all.length > 0 ) {
                // sets the attribute to indicate successful login. see also "layout.tag"
                request.getSession().setAttribute(Constants.AUTHENTICATED_USER_SESSION_KEY, all[0]);
                return PAGE_OK;
            } else {
                // sets data to be displayed by login.jsp
                request.setAttribute(VAR_CURRENT_USERNAME, username);
                addError(request, "errors.invalidCredentials");
                return PAGE_FAIL;
            }

        } catch (Exception e) {
            throw new ActionException(e);
        }
    }

    /**
     * An action should override this method to allow unauthenticated execution
     *
     * @return
     */
    protected boolean shouldCheckAuthentication() {
        return false;
    }
}
