package inet.warehouse.web.tags;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyTagSupport;
import java.io.IOException;

/**
 * Implementation of the menu tag<br/>
 */
public class MenuTag extends BodyTagSupport {
    /**
     * CSS class for the whole menu
     */
    public static final String CSS_CLASS_MENU = "menu";

    /**
     * CSS class for the title
     */
    public static final String CSS_CLASS_TITLE = "menuTitle";


    public int doStartTag() throws JspException {
        JspWriter out = pageContext.getOut();
        try {
            out.print("<table id=\"" + this.id + "\" class=\"menu\"");
            if (this.width.length() > 0) {
                out.print("width=\"" + width + "\"");
            }
            out.println(">");
            out.println("<tr><td class=\"menuTitle\">");
            out.print(this.title);
            out.println("</td></tr>");
        } catch (IOException e) {
            throw new JspException(e);
        }

        return EVAL_BODY_INCLUDE;
    }

    public int doEndTag() throws JspException {
        JspWriter out = pageContext.getOut();
        try {
            out.println("</table>");
        } catch (IOException e) {
            throw new JspException(e);
        }
        return EVAL_PAGE;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) throws IllegalArgumentException {
        if (title == null) {
            throw new IllegalArgumentException("The menu title cannot be null");
        }
        this.title = title;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) throws IllegalArgumentException {
        if ((id == null) || (id.trim().length() == 0)) {
            throw new IllegalArgumentException("The menu id cannot be empty");
        }
        this.id = id;
    }

    public String getWidth() {
        return width;
    }

    public void setWidth(String width) throws IllegalArgumentException {
        if (width == null) {
            throw new IllegalArgumentException("Menu width cannot be null");
        }
        this.width = width;
    }

    public String getExpandSelectedOnly() {
        return "" + this.expandSelectedOnly;
    }

    public void setExpandSelectedOnly(String aExpandSelectedOnly) {
        this.expandSelectedOnly = Boolean.valueOf(aExpandSelectedOnly).booleanValue();
    }

    boolean expandSelectedOnly() {
        return this.expandSelectedOnly;
    }

    public String toString() {
        return "MenuTag: " + this.id;
    }

    private String title = "";
    private String id = "menu";
    private String width = "";
    private boolean expandSelectedOnly = false;
}
